﻿Imports System.Windows.Forms.DataVisualization.Charting
Imports System.Drawing.Drawing2D
Imports System.IO
Imports System
Imports System.Drawing
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Globalization



Public Class form_Leistungsdiagramm

    Private Sub Leistungsdiagramm_Load(sender As Object, e As EventArgs) Handles MyBase.Load


        Dim Daten As New List(Of String)
    Dim Arraylength As Integer

    ' Arraylänge bestimmen und File einlesen

        Using sr As New IO.StreamReader("C:\Motor_9.txt")
            Do
                Daten.Add(sr.ReadLine())
            Loop Until sr.Peek < 0
        End Using
        For Each Zeile As String In Daten
            Arraylength = Arraylength + 1
        Next

    ' Werte Spliten, konvertieren, Impulse zählen

    Dim Zeit(Arraylength) As String
    Dim Impulse(Arraylength) As String

    Dim Impulse_Dbl(Arraylength) As Double
    Dim Zeit_Dbl(Arraylength) As Double

    Dim Impuls_cnt As Integer = 0
    Dim Impuls_cnt_old As Integer = 0

    Dim i As Integer = 1

    Dim Impuls_Zeit(Arraylength) As Double

        For Each Zeile In Daten

    Dim s As String = Zeile
    Dim ss() As String = s.Split(";")

            Zeit(0 + i) = ss(0)
            Impulse(0 + i) = ss(1)

            Impulse_Dbl(0 + i) = CDbl(Impulse(0 + i))
            Zeit_Dbl(0 + i) = CDbl(Zeit(0 + i))

    'Hysterese

            If Impulse_Dbl(0 + i) > 1 And Impuls_cnt = Impuls_cnt_old Then
                Impuls_cnt = Impuls_cnt + 1
                Impuls_Zeit(0 + Impuls_cnt) = Zeit_Dbl(0 + i)

            End If

            If Impulse_Dbl(0 + i) < 0.5 And Impuls_cnt <> Impuls_cnt_old Then
                Impuls_cnt_old = Impuls_cnt_old + 1
            End If

            i = i + 1

        Next

    'Zeit pro Impuls Umdrehungen_pro_Impuls und Drehzahl berechnen

        Dim n As Integer = 1
        Dim Umdrehungen_pro_Impuls(Impuls_cnt) As Double
        Dim Gesamtzeit(Arraylength) As Double
        Dim Anzeige(Impuls_cnt) As Integer
        Dim Drehzahl(Impuls_cnt) As Integer

        Anzeige(0) = 0

        For index = 1 To (Impuls_cnt - 1) Step 1

            Gesamtzeit(0 + n) = Impuls_Zeit(1 + n) - Impuls_Zeit(0 + n)

            Umdrehungen_pro_Impuls(0 + n) = 60 / ((Gesamtzeit(0 + n) / 1000))

            Anzeige(0 + n) = n
            Drehzahl(0 + n) = (n / (Impuls_Zeit(0 + n) / 1000)) * 60
            TextBox1.Text = TextBox1.Text & Gesamtzeit(0 + n) & vbCrLf
            TextBox2.Text = TextBox2.Text & Umdrehungen_pro_Impuls(0 + n) & vbCrLf
            TextBox5.Text = TextBox5.Text & Anzeige(0 + n) & vbCrLf
            TextBox6.Text = TextBox6.Text & Drehzahl(0 + n) & vbCrLf
    'Beschleunigung(0 + n) = 0.029 / (Gesamtzeit(0 + n) / 1000) ^ 2
            n = n + 1

        Next

    'Drehmoment und Leistung berechnen

    Dim Drehmoment(Impuls_cnt) As Double
    Dim Leistung(Impuls_cnt) As Double
    Dim Massentreagheit As Double = 4.7
        Drehmoment(1) = 0
        Leistung(1) = 0

    Dim f As Integer = 1
        For index = 1 To (Impuls_cnt - 1)

            Drehmoment(1 + f) = Massentreagheit * 2 * System.Math.PI * 0.22027 * ((Umdrehungen_pro_Impuls(1 + f) - Umdrehungen_pro_Impuls(0 + f)) / (60 * ((Gesamtzeit(1 + f)) / 1000)))
            Leistung(1 + f) = (1 / (Gesamtzeit(1 + f) / 1000)) * 2 * System.Math.PI * Drehmoment(1 + f)
            TextBox3.Text = TextBox3.Text & Drehmoment(0 + f) & vbCrLf
            TextBox4.Text = TextBox4.Text & Leistung(0 + f) & vbCrLf
            f = f + 1

        Next


        ' Graph darstellen

        Ch_Leistung.Series.Clear()
        Ch_Leistung.Titles.Add("Leistungsdiagramm")
    Dim c As New Series
        c.Name = "Leistung in [PS]"
        c.ChartType = SeriesChartType.Line

    Dim d As New Series

        d.Name = "Drehmoment in [Nm]"
        d.ChartType = SeriesChartType.Line

        ' Graph darstellen

        Dim Eigenschaften As New Graph

        Dim h As Integer = 1

        For index = 1 To (Impuls_cnt - 1)

            'alle negativen werte eleminieren

            'If Leistung(0 + h) > 0 Then
            c.Points.AddXY(Drehzahl(0 + h), Leistung(0 + h))
            d.Points.AddXY(Drehzahl(0 + h), Drehmoment(0 + h))

            'z.AddValue(Leistung(0 + h))
            Eigenschaften.AddValue(Leistung(0 + h))
            ' Eigenschaften.AddValue(Drehmoment(0 + h))
            'End If
            Eigenschaften = Graph1
            h = h + 1
            PropertyGrid1.SelectedObject = Eigenschaften
        Next

        Ch_Leistung.Series.Add(c)
        Ch_Leistung.Series.Add(d)

        Label7.Text = Leistung.Max
        Label8.Text = Drehmoment.Max
        Label2.Text = Impuls_cnt
        'TextBox7.Text = TextBox7.Text & Impuls_Zeit(22) & vbCrLf & Leistung(1) & vbCrLf & Leistung(2) & vbCrLf & Leistung_Avg(1) & vbCrLf & Leistung_Avg(2) & vbCrLf & Leistung_Avg(3) & vbCrLf


    End Sub
End Class

'Dim d As New Series

'd.Name = "Drehmoment in [Nm]"
''Change to a line graph.

'd.ChartType = SeriesChartType.Line
'd.Points.AddXY("2000", 48)
'd.Points.AddXY("2500", 45)
'd.Points.AddXY("3000", 54)
'Ch_Leistung.Series.Add(d)    


'Dim Pfad As String = ""
'Dim Dateiname As String = ""
'Dim Beschriebung(10) As String

'Dim cnt As Integer = 0

'If Zeile = "" Then
'    cnt = 10
'End If

'Select Case cnt

'    Case 0

'        If i = 0 Then
'            Pfad = Zeile
'            cnt = 1
'        End If

'    Case 1
'        If i = 1 Then
'            Dateiname = Zeile
'            cnt = 2
'        End If

'    Case 2
'        If i = 2 Then
'            Beschriebung(0) = Zeile
'            cnt = 3
'        End If

'    Case 3
'        If i = 3 Then
'            Beschriebung(1) = Zeile
'            cnt = 4
'        End If

'    Case 4
'        If i = 4 Then
'            Beschriebung(2) = Zeile
'            cnt = 5
'        End If

'    Case 5
'        If i = 5 Then
'            Beschriebung(3) = Zeile
'            cnt = 5
'        End If

'    Case 10

'        MsgBox("Fehler beim einlesen der Zeile" & i)
'        cnt = 0
'End Select

'lbl_Pfad.Text = Pfad
'lbl_Name.Text = Dateiname
'lbl_Beschreibung.Text = Beschriebung(0)
'lbl_Beschreibung_2.Text = Beschriebung(1)
'lbl_Beschreibung_3.Text = Beschriebung(2)
'lbl_Beschreibung_4.Text = Beschriebung(3)



'Dim fileReader As System.IO.StreamReader
'fileReader = My.Computer.FileSystem.OpenTextFileReader("C:\Users\Johannes.Kafka\Desktop\Sicherung\test_2.txt")
'Dim stringReader As String
'stringReader = fileReader.ReadLine()
'MsgBox("The first line of the file is " & stringReader)
